// Importing modules
const { app, BrowserWindow, ipcMain } = require('electron')
const path = require('path')

// Reusable function to instantiate windows
const createWindow = () => {
    const win = new BrowserWindow({
        width: 800,
        height: 600,
        webPreferences: {
            preload: path.join(__dirname, 'preload.js'),
        }
    })
    ipcMain.handle('ping', () => 'pong')
    win.loadFile('index.html')
}

// Call window instantiating function when the app is ready
app.whenReady().then(() => {
    createWindow()

    // Open a window if none are open (macos only)
    app.on('activate', () => {
        if (BrowserWindow.getAllWindows().length === 0) {
            createWindow()
        }
    })
})

// Quit the app when all windows are closed (for windows and linux only)
app.on('window-all-closed', () => {
    if (process.platform !== 'darwin') app.quit()
})
